#! /usr/bin/perl -w
#
# v0.52 : concordance entre aide et parametres par defaut, option -pf, correction option -f
# v0.51 : parametres par defaut
# v0.50 : aide
# v0.21 : mode de passage des options
# v0.12.1 : correction des permissions donnees lors de la creation du repertoire des vignettes
# v0.12 : version originale, fournie avec yamig 0.12

$usage = <<EOT;

Usage : ./yamig-thumbnails.pl [-s=sourcedir] [-d=destdir] [-p=pixels] [-f=filter] [-pf=prefix]
Defaults : -s="." -d="thumbs" -p=150 -f="*" -pf="t_"

EOT

# Is convert available ?
$convert = 'convert' ;
scalar grep /ImageMagick/, `$convert -version` or die "ImageMagick $convert utility does not seem to be available, bye.\nError" ;

# Get parameters
$sourcedir = '.' ;
$destdir = 'thumbs' ;
$pixels = 150 ;
@filters = () ;
$prefix = 't_' ;
foreach (@ARGV)
	{
	($option, $value) = split /=/ ;
	print $usage and exit if ($option =~ /^(-|--|\/)(\?|h|help)$/) ;
	$sourcedir = $value   if ($option eq '-s') ;
	$destdir = $value     if ($option eq '-d') ;
	$pixels = $value      if ($option eq '-p') ;
	push @filters, $value if ($option eq '-f') ;
	$prefix = $value      if ($option eq '-pf') ;
	}
$sourcedir .= '/' if ($sourcedir !~ /\/$/) ;
$pixels2 = $pixels . 'x' . $pixels ;
push @filters, '*' if (!scalar @filters) ;

# Check destdir availability or try to create it.
-d($destdir) or mkdir $destdir, 0755 or die "I can't mkdir $destdir, bye.\nError" ;

# Create thumbnails
print "\n" ;
foreach $filter (@filters)
	{
	@files = glob $sourcedir . $filter ;
	print "No file found with input filter \"$filter\".\n" if (!scalar @files) ;
	foreach $file (@files)
		{
		next if (!-f($file)) ;
		($name = $file) =~ s/.*\/(.*)/$1/ ; # Drop path and just keep filename
		$cmd = "$convert -verbose -resize $pixels2 $file $destdir/$prefix$name" ;
		print `$cmd`, "\n" ;
		}
	}

