<?php
$yamig = "yamig 1.01" ;
/* Yet Another Minimalist Image Gallery !
 * Lightweight : one file.
 * Usage:
 * Option 1 : adapt default settings in yamig.php and install the file with your images
 * Option 2 : install the original yamig.php and create <whatever>.php that defines your settings before including yamig.php
 *
 * Written by Frederic LE FOLL (frederic       @     fr) __    /  \__
 * ___________________________          .lefoll free.      \__/      \_________ !
 * Contribution by Matthieu E. Merci Matthieu !
 *
 * This software is distributed under GPL 2 License (http://www.gnu.org/copyleft/gpl.html)
 */

/* Activate error_reporting() and ini_set() instructions below if you want to override PHP default settings (php.ini) */
//error_reporting(E_ALL) ;
//ini_set('display_errors', 'On') ;

/* You may define here captions for your pictures.
 * Notice : if you chose Option 2 (one yamig.php, many <whatever>.php), define captions in each <whatever>.php files instead. */
/*
$yamig_caption = array (
	'picture1.jpg' => 'text for caption 1',
	...
	'pictureN.jpg' => 'text for caption N'
	) ;
*/

/* Set default settings if custom settings are not already set */
if (!isset($yamig_backhome))       $yamig_backhome = '..' ;
if (!isset($yamig_pics_dir))       $yamig_pics_dir = '.' ;
if (!isset($yamig_pics_prefix))    $yamig_pics_prefix = '' ;
if (!isset($yamig_thumbs_dir))     $yamig_thumbs_dir = 'thumbs' ;
if (!isset($yamig_thumbs_prefix))  $yamig_thumbs_prefix = 't_' ;
if (!isset($yamig_thumbs_size))    $yamig_thumbs_size = 150 ; /* Set to 0 to disable thumbnails generation */
if (!isset($yamig_fullres_dir))    $yamig_fullres_dir = 'fullres' ; /* Set to '' to disable links to fullres */
if (!isset($yamig_fullres_prefix)) $yamig_fullres_prefix = '' ;
if (!isset($yamig_def_resize))     $yamig_def_resize = 1 ;
if (!isset($yamig_def_skin))       $yamig_def_skin = 'std' ;
if (!isset($yamig_free_skin))      $yamig_free_skin = TRUE ;
if (!isset($yamig_def_delay))      $yamig_def_delay = 10 ;
if (!isset($yamig_headline))       $yamig_headline = $_SERVER["SERVER_NAME"] . preg_replace('/(.*\/).*/', '$1', $_SERVER['PHP_SELF']) ;
if (!isset($yamig_ui))             $yamig_ui = array (
	'home' => 'Home',
	'index' => 'Index',
	'prev' => 'Prev',
	'nop' => '',
	'next' => 'Next',
	'apply' => 'Apply',
	'play' => 'Play',
	'stop' => 'Stop',
	'tip_skin' => 'Select skin',
	'tip_resize' => 'Select best sizing option, depending on your browser version',
	'tip_apply' => 'Apply selected skin and sizing options',
	'tip_delay' => 'Select refresh rate',
	'tip_play' => 'Start slideshow',
	'tip_stop' => 'Stop slideshow',
	'tip_index' => 'Back to thumbnails',
	'tip_prev' => 'Previous image',
	'tip_next' => 'Next image',
	'resize' => array ('100%', 'Auto', 'Auto-h', 'Auto-w', '640x480', '800x600', '1024x768')) ;
if (!isset($yamig_blk))           $yamg_blk = 'div' ;
if (!isset($yamig_css))           $yamig_css = array (
	'html, body' => '{ width: 100%; height: 100%; margin: 0px; padding: 0px; }',
	'#page' => '{ position: absolute; width: 100%; height: 100%; color: black; background-color: white; /* background-image: url(/images/bg.jpg); */ font-family: Arial,Helvetica,sans-serif; font-size: small; }',
	'#headline_area' => '{ position: absolute; top: 0em; left: 10em; right: 0em; height: 2em; text-align: center; font-weight: bold; }',
	'#control_area' => '{ position: absolute; top: 2em; left: 0em; width: 7em; margin: 2px; padding: 0.5em; color: black; background-color: #F0F0F0; border: 2px outset black; text-align: center; }',
	'#control_area *' => '{ margin: 1px; }',
	'#control_area a' => '{ color: black; }',
	'#control_area .scontrol' => '{ margin: 1em 0px; }',
	'#control_area .control_select' => '{ width: 6em; }',
	'#control_area .control_submit' => '{ width: 4em; }',
	'#control_area .control_image' => '{ vertical-align: bottom; }',
	'#index_area' => '{ position: absolute; top: 2em; left: 10em; right: 0em; bottom: 0px; text-align: center; overflow: auto; }',
	'#index_area img' => '{ border: 2px outset black; margin: 8px; padding: 2px; background-color: white; }',
	'#index_area img:hover' => '{ border: 3px outset black; margin: 7px; padding: 2px; }',
	'#image_area' => '{ position: absolute; top: 2em; left: 10em; right: 0em; bottom: 0em; text-align: center; }',
	'#image_area a img' => '{ border: 0px; }') ;

/* Pre-defined skins : each skin is defined by a block style ('div' for vertical controls, 'span' for horizontal controls) and a customized CSS.
   The customized CSS can be :
   - either extensively defined in a string,
   - or defined as a variation of default $yamig_css in an array that only enumerated modified styles.
   */
$yamig_skin['std']['blk'] = 'div' ;
$yamig_skin['std']['css'] = array () ; /* Just use default yamig_css */
$yamig_skin['clear']['blk'] = 'div' ;
$yamig_skin['clear']['css'] = array (
	'#control_area' => '{ position: absolute; top: 2em; left: 0em; width: 7em; margin: 2px; padding: 0.5em; color: black; background-color: #ADFF2F; border: 2px outset green; text-align: center; }') ;
$yamig_skin['clear-h']['blk'] = 'span' ;
$yamig_skin['clear-h']['css'] = array (
	'#headline_area' => '{ position: absolute; top: 0em; left: 0em; right: 0em; height: 2em; text-align: center; color: gray; font-size:large; font-weight: bold; }',
	'#control_area' => '{ position: absolute; top: 2em; left: 0em; right: 0em; padding: 4px; color: black; background-color: #ADFF2F; text-align: center; }',
	'#control_area .scontrol' => '{ margin: 0px 1em; }',
	'#index_area' => '{ position: absolute; top: 6em; left: 0em; right: 0em; bottom: 0px; text-align: center; overflow: auto; }',
	'#image_area' => '{ position: absolute; top: 6em; left: 0em; right: 0em; bottom: 0em; text-align: center; }') ;
/* $yamig_skin['clear-h']['icons'] = array (
	'index' => $_SERVER['DOCUMENT_ROOT'] . '/images/top.png',
	'prev'  => $_SERVER['DOCUMENT_ROOT'] . '/images/back.png',
	'next'  => $_SERVER['DOCUMENT_ROOT'] . '/images/forward.png',
	'nop'   => $_SERVER['DOCUMENT_ROOT'] . '/images/fileclose.png',
	'apply' => $_SERVER['DOCUMENT_ROOT'] . '/images/configure.png',
	'play'  => $_SERVER['DOCUMENT_ROOT'] . '/images/player_play.png',
	'stop'  => $_SERVER['DOCUMENT_ROOT'] . '/images/player_stop.png') ; */ /* You may define in $yamig_skin[<skin>]['icons'] icons that will replace standard buttons */
$yamig_skin['dark']['blk'] = 'div' ;
$yamig_skin['dark']['css'] = array (
	'#page' => '{ position: absolute; width: 100%; height: 100%; color: white; background-color: black; font-family: Arial,Helvetica,sans-serif; font-size: small; }',
	'#control_area' => '{ position: absolute; top: 2em; left: 0em; width: 7em; margin: 2px; padding: 0.5em; color: white; background-color: navy; border: 3px ridge #00008B; text-align: center; }',
	'#control_area a' => '{ color: white; }') ;
$yamig_skin['dark-h']['blk'] = 'span' ;
$yamig_skin['dark-h']['css'] = array (
	'#page' => '{ position: absolute; width: 100%; height: 100%; color: white; background-color: black; font-family: Arial,Helvetica,sans-serif; font-size: small; }',
	'#headline_area' => '{ position: absolute; top: 0em; left: 0em; right: 0em; height: 2em; text-align: center; font-weight: bold; }',
	'#control_area' => '{ position: absolute; top: 2em; left: 0em; right: 0em; padding: 4px; color: white; background-color: navy; text-align: center; }',
	'#control_area a' => '{ color: white; }',
	'#control_area .scontrol' => '{ margin: 0px 1em; }',
	'#index_area' => '{ position: absolute; top: 6em; left: 0em; right: 0em; bottom: 0px; text-align: center; overflow: auto; }',
	'#image_area' => '{ position: absolute; top: 6em; left: 0em; right: 0em; bottom: 0em; text-align: center; }') ;
$yamig_skin['serious']['blk'] = 'div' ;
$yamig_skin['serious']['css'] = array (
	'#page' => '{ position: absolute; width: 100%; height: 100%; color: white; background-color: black; font-family: Arial,Helvetica,sans-serif; font-size: small; }',
	'#headline_area' => '{ position: absolute; top: 8px; left: 8px; right: 8px; height: 64px; color: teal; background-color: #E0E0E0; padding: 0px 0.5em; text-align: left; font-size: 200%; }',
	'#control_area' => '{ position: absolute; top: 80px; left: 8px; width: 128px; bottom: 8px; color: black; background-color: #E0E0E0; text-align: center; }',
	'#control_area a' => '{ color: black; }',
	'#index_area' => '{ position: absolute; top: 80px; left: 144px; right: 8px; bottom: 8px; color: black; background-color: white; text-align: center; overflow: auto; }',
	'#index_area img' => '{ border: 0px; margin: 8px; padding: 0px; }',
	'#index_area img:hover' => '{ border: 0px; margin: 8px; padding: 0px; }',
	'#image_area' => '{ position: absolute; top: 80px; left: 144px; right: 8px; bottom: 8px; color: black; background-color: white; text-align: center; padding-top: 2%; }') ;
$yamig_skin['transp']['blk'] = 'div' ;
$yamig_skin['transp']['css'] = array (
	'#page' => '{ position: absolute; width: 100%; height: 100%; color: black; background-color: #E0FFFF; font-family: Arial,Helvetica,sans-serif; font-size: small; }',
	'#headline_area' => '{ position: absolute; top: 0em; left: 10em; right: 0em; height: 2em; color: blue; text-align: center; font-weight: bold; }',
	'#control_area' => '{ position: absolute; top: 2em; left: 0em; width: 7em; margin: 2px; padding: 0.5em; text-align: center; }') ;

function build_control(&$skin, $control, $name)
	{
	global $yamig_ui ;

	$control = isset($skin['icons']) && isset($skin['icons'][$control]) ?
	           ('<input class="control_image" type="image" name="' . $name . '"' .
	            ' title="' . htmlentities(isset($yamig_ui["tip_$control"]) ? $yamig_ui["tip_$control"] : $yamig_ui[$control], ENT_COMPAT, 'UTF-8') . '"' .
	            ' src="' . $skin['icons'][$control] . '" alt="' . htmlentities($yamig_ui[$control], ENT_COMPAT, 'UTF-8') . '" />') :
	           ('<input class="control_submit" type="submit" name="' . $name . '"' .
	            (isset($yamig_ui["tip_$control"]) ?
	             ' title="' . htmlentities($yamig_ui["tip_$control"], ENT_COMPAT, 'UTF-8') . '"' :
	             '') .
	            '  value="' . htmlentities($yamig_ui[$control], ENT_COMPAT, 'UTF-8') . '" />') ;
	return $control ;
	}

/* Optional thumbnails generation */
if ($yamig_thumbs_size &&
    function_exists('gd_info') &&
    (!is_dir($yamig_thumbs_dir) || file_exists("$yamig_thumbs_dir/progress")))
	{
	print "Trying to create thumbnails ...<br/>\n" ;
	if (!is_dir($yamig_thumbs_dir) && !mkdir($yamig_thumbs_dir, 0755))
		print "Thumbnails directory creation failed. Sorry, won't be able to create thumbnails.<br/>\n" and exit ;
	/* 2007-06-29 - file_put_contents() failed on Free server. Let's use fopen/fwrite/fclose instead */
	if (/* !file_put_contents("$yamig_thumbs_dir/progress", "In progress ...\n") */
	    !($h = fopen("$yamig_thumbs_dir/progress", 'w')) || !fwrite($h, "In progress ...\n") || !fclose($h))
		print "File insertion in thumbnails directory failed. Sorry, won't be able to create thumbnails.<br/>\n" and exit ;

	if (file_exists("$yamig_thumbs_dir/progress"))
		{
		$pics = 0 ;
		$handle_p = opendir($yamig_pics_dir) ;
		while (false !== ($file_p = readdir($handle_p))) /* browse pictures directory */
			{
			if (filetype("$yamig_pics_dir/$file_p") != 'file' ||
			    preg_match('/\.(php|html?)$/', $file_p) ||
			    $yamig_pics_prefix && !preg_match("/^$yamig_pics_prefix/", $file_p))
				continue ;
			$pics++ ;
			$file = $yamig_pics_prefix ? preg_replace("/^$yamig_pics_prefix/", '', $file_p) : $file_p ;
			if (!file_exists("$yamig_thumbs_dir/$yamig_thumbs_prefix$file"))
				{
				list ($width, $height, $type) = getimagesize("$yamig_pics_dir/$file_p") ;
				$ratio = $yamig_thumbs_size / max($yamig_thumbs_size, $width, $height) ;
				$newwidth = $width * $ratio ;
				$newheight = $height * $ratio ;
				$thumb = imagecreatetruecolor($newwidth, $newheight) ;
				switch ($type)
					{
				case IMAGETYPE_GIF :  $source = imagecreatefromgif("$yamig_pics_dir/$file_p") ; break ;
				case IMAGETYPE_PNG :  $source = imagecreatefrompng("$yamig_pics_dir/$file_p") ; break ;
				case IMAGETYPE_JPEG : $source = imagecreatefromjpeg("$yamig_pics_dir/$file_p") ; break ;
				default :             print "Image type for '$file_p' not supported. Sorry..<br/>\n" ; continue ;
					}
				/* Notice : imagecopyresampled() gives a better result than imagecopyresized() but takes much longer ! */
				//imagecopyresized($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height) ;
				imagecopyresampled($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height) ;
				switch ($type)
					{
				case IMAGETYPE_GIF :  imagegif($thumb, "$yamig_thumbs_dir/$yamig_thumbs_prefix$file") ; break ;
				case IMAGETYPE_PNG :  imagepng($thumb, "$yamig_thumbs_dir/$yamig_thumbs_prefix$file") ; break ;
				case IMAGETYPE_JPEG : imagejpeg($thumb, "$yamig_thumbs_dir/$yamig_thumbs_prefix$file") ; break ;
				default :             /* NOP ... */
					}
				}
			}
		closedir($handle_p) ;
		unlink("$yamig_thumbs_dir/progress") ; /* File 'progress' will be deleted only when all pictures are processed. */
		}
	}

/* Images inventory */
$thumbnails = 0 ;
$index = array () ;
$handle_t = opendir($yamig_thumbs_dir) ;
while (false !== ($file_t = readdir($handle_t))) /* yamig is "thumbnail-driven" : no thumbnail => no picture ! */
	{
	if (filetype("$yamig_thumbs_dir/$file_t") != 'file' ||
	    preg_match('/\.(php|html?)$/', $file_t) ||
	    $yamig_thumbs_prefix && !preg_match("/^$yamig_thumbs_prefix/", $file_t))
		continue ;
	$thumbnails++ ;
	$file = $yamig_thumbs_prefix ? preg_replace("/^$yamig_thumbs_prefix/", '', $file_t) : $file_t ;
	if (file_exists("$yamig_pics_dir/$yamig_pics_prefix$file") && filetype("$yamig_pics_dir/$yamig_pics_prefix$file") == 'file')
		$index[] = $file ;
	}
closedir($handle_t) ;
sort($index) ;

/* Analyse user request */
$url = $_SERVER['PHP_SELF'] ;
$resizestyles = array (
	'',
	'style="max-width: 95%; max-height: 95%; margin-top: auto; margin-bottom: auto;"',
	'style="max-height: 95%;"',
	'style="max-width: 95%;"',
	'style="max-width: 640px; max-height: 480px;"',
	'style="max-width: 800px; max-height: 600px;"',
	'style="max-width: 1024px; max-height: 768px;"') ;
$delays = array (5, 10, 15, 20, 30, 60) ;
$skin_names = array_keys($yamig_skin) ;
if ($yamig_def_skin == '*')
	$yamig_def_skin = $skin_names[rand(0, count($skin_names) - 1)] ;
$resize = isset($_REQUEST['resize']) ? $_REQUEST['resize'] : $yamig_def_resize ;
$delay = isset($_REQUEST['delay']) ? $_REQUEST['delay'] : $yamig_def_delay ;
$skin_name = $yamig_free_skin && isset($_REQUEST['skin']) && in_array($_REQUEST['skin'], $skin_names) ? $_REQUEST['skin'] : $yamig_def_skin ;
$skin = &$yamig_skin[$skin_name] ;
$blk = isset($skin['blk']) ? $skin['blk'] : $yamig_blk ;
if (is_array($skin['css'])) /* CSS defined as an array, or as a string ? */
	{
	/* Array : merge skin-specific styles and yamig default styles */
	$css = '' ;
	$yamig_css = array_merge($yamig_css, $skin['css']) ;
	foreach (array_keys($yamig_css) as $style)
		$css .= "$style $yamig_css[$style]\n" ;
	}
else
	{
	/* String : directly use skin-specific CSS definition */
	$css = $skin['css'] ;
	}
$getvars = array ("resize=$resize", "delay=$delay") ; /* Array */
if ($yamig_free_skin)
	$getvars[] = "skin=$skin_name" ;
if (isset($_REQUEST['index']))
	{
	header("Refresh: 0; URL=$url?" . implode('&', $getvars)) ;
	exit ;
	}
$getvars = implode('&amp;', $getvars) ; /* String from now on */
$resizestyle = $resizestyles[$resize] ;
if (isset($_REQUEST['show']['prev']) || isset($_REQUEST['show']['next']) || isset($_REQUEST['show']['apply']) || isset($_REQUEST['show']['stop']))
	unset ($_REQUEST['show']['current']) ; /* Manual controls have priority over auto-play */
$current = isset($_REQUEST['show']['current']) ? $_REQUEST['show']['current'] : (isset($_REQUEST['current']) ? $_REQUEST['current'] : 0) ;
$current = $current + (isset($_REQUEST['show']['next']) && ($current < count($index) - 1)) - (isset($_REQUEST['show']['prev']) && ($current > 0)) ;
$play = isset($_REQUEST['show']['play'])  && !isset($_REQUEST['show']['stop']) ;
if ($play)
	{
	$next = $current < count($index) - 1 ? $current + 1 : 0 ;
	if (isset($_REQUEST['autostop']))
		{
		$autostop = $_REQUEST['autostop'] ;
		if ($next != $autostop)
			$url .= "?$getvars&amp;autostop=$autostop&amp;show[play]=1&amp;show[current]=$next" ;
		else
			$url .=  "?$getvars" ;
		}
	else
		$url .= "?$getvars&amp;autostop=$current&amp;show[play]=1&amp;show[current]=$next" ;
	}

/* Generate HTML header, including title, CSS and auto-refresh */
$hrec = '<?xml version="1.0" encoding="utf-8" ?>' ;
$htitle = htmlentities(($yamig_headline ? "$yamig_headline - " : '') . 'yamig Image Gallery', ENT_COMPAT, 'UTF-8') ;
$hrefresh = $play ? " <meta http-equiv=\"refresh\" content=\"$delay;url=$url\" />" : '' ;
print <<<EOT
$hrec
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
 <meta content="text/html; charset=UTF-8" http-equiv="content-type" />
 <title>$htitle</title>
 <style type="text/css">
$css </style>
$hrefresh
</head>
<body>
<div id="page">


EOT;

if (isset($_REQUEST['help']))
	{
	print <<<EOT
	<div style="position: absolute; padding: 8px; margin-left: 10%; margin-top: 5%; width: 80%; height: 80%; border: 2px ridge black; overflow: auto;">
	<h1>A propos de yamig</h1>
	<h2>Homepage</h2>
	<p><a href = "http://vracbazar.free.fr">http://vracbazar.free.fr</a><br/>Rubrique "Yet Another Minimalist Image Gallery&nbsp;!"</p>
	<h2>Redimensionnement des images</h2>
	<p>Afin de permettre la consultation des galeries sur des écrans de tailles variées,
	yamig comporte une fonction de redimensionnement automatique des images.</p>
	<p>Les options sont les suivantes :</p>
	<ul>
	 <li>100% : pas de redimensionnement.</li>
	 <li>Auto : automatique, selon la largeur et la hauteur de la fenêtre du navigateur.</li>
	 <li>Auto-h : automatique, uniquement selon la hauteur de la fenêtre du navigateur.</li>
	 <li>Auto-w : automatique, uniquement selon la largeur la fenêtre du navigateur.</li>
	 <li>640x480 / 800x600 / 1024x768 : automatique dans les limites fixes indiquées.</li>
	</ul>
	<p>Malheureusement, les réactions des différents navigateurs à ce redimensionnement, qui utilise les attributs de style max-width et max-height,
	 sont assez variables d&rsquo;un logiciel à l&rsquo;autre.
	Ci-dessous un résumé des comportement constatés :</p>
	<ul>
	 <li><b>Firefox 1.5, 2.0, SeaMonkey 1.0, 1.1, Opera 9</b> : toutes les options fonctionnent correctement
	 (Opera grâce à une astuce de &lt;div&gt; intermédiaire&nbsp;... Merci Matthieu !).</li>
	 <li><b>Mozilla 1.7</b> : toutes les options fonctionnent correctement ... tant que l&rsquo;une des dimensions de l&rsquo;image est inférieure à la limite
	 (soit en largeur, soit en hauteur). Si les deux dimensions dépassent les limites, l&rsquo;image s&rsquo;inscrit
	 précisément dans les limites en question, sans respect des proportions de l&rsquo;image&nbsp;!
	 Cette observation concerne les options Auto, 640x480, 800x600, 1024x768.</li>
	 <li><b>IE6</b> : c&rsquo;est simple : il ne tient aucun compte des indications de taille de l&rsquo;image&nbsp;!
	 Pour être positif, l&rsquo;option 100% fonctionne parfaitement ;-)</li>
	 <li><b>IE7, Konqueror 3.5</b> : toutes les options fonctionnent correctement, à l&rsquo;exception de Auto et Auto-h, car ces navigateurs ne
	 semblent pas tenir compte de l&rsquo;attribut max-height exprimé en % sur l&rsquo;image (alors que max-width en % est respecté).</li>
	</ul>
	<p>Remarque : ces remarques sur le redimensionnement ne concernent pas la page des vignettes,
	qui est élaborée à partir de fichiers de taille réduite, beaucoup plus légers à transférer.</p>
	<h2>Perspectives d&rsquo;évolution</h2>
	<p>Encore des améliorations des feuilles de style de yamig, pour une meilleure compatibilité avec les différents navigateurs&nbsp;?</p>
	<p>Utilisation de Javascript côté navigateur et/ou de GD côté serveur Web pour gérer les redimensionnements&nbsp;?</p>
	<p>A suivre&nbsp;...</p>
	<h2>Retour</h2>
	<p>Pour revenir à la galerie, <a href = "javascript:history.back()">cliquez ici</a> ou utilisez la fonction "Page précédente" de votre navigateur.</p>
	<p>&nbsp;</p>
	</div>
	</div>
	</body>
	</html>
EOT;
	exit ;
	}

/* Generate Headline area */
print "<div id=\"headline_area\">\n" . htmlentities($yamig_headline, ENT_COMPAT, 'UTF-8') . "\n</div>\n\n" ;

if (isset($_REQUEST['show'])) /* Image browsing mode */
	{

	/* Generate Controls area */
	$prev = $current > 0 ? 'prev' : 'nop' ;
	$control_prev = $current > 0 ? 'show[prev]' : 'show[nop]' ;
	$next = $current < count($index) - 1 ? 'next' : 'nop' ;
	$control_next = $current < count($index) - 1 ? 'show[next]' : 'show[nop]' ;
	if ($yamig_free_skin)
		{
		$skinoptions = '' ;
		for ($i = 0 ; $i < count($skin_names) ; $i++)
			$skinoptions .= "<option value=\"$skin_names[$i]\"" . ($skin_name == $skin_names[$i] ? " selected=\"selected\"" : "") . ">$skin_names[$i]</option>" ;
		$select_skin = "<select class=\"control_select\" name=\"skin\" title=\"" .
		               htmlentities($yamig_ui['tip_skin'], ENT_COMPAT, 'UTF-8') . "\">$skinoptions</select>" ;
		}
	else
		$select_skin = '' ;
	$resizeoptions = '' ;
	for ($i = 0 ; $i < count($resizestyles) ; $i++)
		$resizeoptions .= "<option value=\"$i\"" . ($resize == $i ? ' selected="selected"' : '') . '>' . htmlentities($yamig_ui['resize'][$i], ENT_COMPAT, 'UTF-8') . '</option>' ;
	$select_resize = "<select class=\"control_select\" name=\"resize\" title=\"" .
	                 htmlentities($yamig_ui['tip_resize'], ENT_COMPAT, 'UTF-8') . "\">$resizeoptions</select>" ;
	$cmd_apply = build_control($skin, 'apply', 'show[apply]') ;
	print "<form action=\"$url\" method=\"post\"><div id=\"control_area\">\n" .
	      " <$blk class=\"scontrol\">\n" .
	      "  <a href=\"$url?$getvars&amp;help\" title=\"Help\">$yamig</a>\n  <$blk>$select_skin</$blk>\n <$blk>$select_resize</$blk>\n  <$blk>$cmd_apply</$blk>\n </$blk>\n" ;
	if (!$play)
		{
		$delayoptions = '' ;
		for ($i = 0 ; $i < count($delays) ; $i++)
			$delayoptions .= "<option value=\"$delays[$i]\"" . ($delay == $delays[$i] ? " selected=\"selected\"" : "") . ">$delays[$i] s</option>" ;
		$select_delay = "<select class=\"control_select\" name=\"delay\" title=\"" .
		                htmlentities($yamig_ui['tip_delay'], ENT_COMPAT, 'UTF-8') . "\">$delayoptions</select>" ;
		$cmd_play = build_control($skin, 'play', 'show[play]') ;
		print " <$blk class=\"scontrol\">\n  <$blk>$select_delay</$blk>\n  <$blk>$cmd_play</$blk>\n </$blk>\n" ;
		}
	else
		{
		$cmd_stop = build_control($skin, 'stop', 'show[stop]') ;
		print " <$blk class=\"scontrol\">\n  <$blk>$delay&nbsp;s&nbsp;...</$blk>\n  $cmd_stop\n </$blk>\n" ;
		}
	$cmd_index = build_control($skin, 'index', 'index') ;
	$cmd_prev = build_control($skin, $prev, $control_prev) ;
	$cmd_next = build_control($skin, $next, $control_next) ;
	print " <$blk class=\"scontrol\">\n  <$blk>$cmd_index</$blk>\n  <$blk>$cmd_prev</$blk>\n  <$blk>$cmd_next</$blk>\n </$blk>\n" .
	      " <$blk><input type=\"hidden\" name=\"current\" value=\"$current\" /></$blk>\n" .
	      " <$blk class=\"scontrol\">" . ($current + 1) . "&nbsp;/&nbsp;" . count($index) . "</$blk>\n".
	      "</div></form>\n\n" ;

	/* Generate Image area
	   Embedded div has the very same dimensions as image_area, but its width/height attributes help Opera resizing image. Thanks Matthieu ! */
	print "<div id=\"image_area\"><div style=\"width: 100%; height: 100%\">\n" ;
	if (isset($index[$current]))
		{
		$fullres = $yamig_fullres_dir &&
		           file_exists("$yamig_fullres_dir/$yamig_fullres_prefix$index[$current]") &&
		           filetype("$yamig_fullres_dir/$yamig_fullres_prefix$index[$current]") == 'file' ;
		if ($fullres)
			print "<a href=\"$yamig_fullres_dir/$yamig_fullres_prefix$index[$current]\">\n" ;
		print "<img $resizestyle src=\"$yamig_pics_dir/$yamig_pics_prefix$index[$current]\" alt=\"\" />\n" ;
		if ($fullres)
			print "</a>\n" ;
		if (isset($yamig_caption[$index[$current]]))
			print '<div>' . htmlentities($yamig_caption[$index[$current]], ENT_COMPAT, 'UTF-8') . "</div>\n" ;
		}
	print "</div></div>\n\n" ;
	}

else /* Thumbnails index mode */
	{

	/* Generate Controls area */
	print "<div id=\"control_area\">\n <$blk class=\"scontrol\"><a href=\"$url?$getvars&amp;help\" title=\"Help\">$yamig</a></$blk>\n" .
	      " <$blk class=\"scontrol\"><a href=\"$yamig_backhome\">" . htmlentities($yamig_ui['home'], ENT_COMPAT, 'UTF-8') . "</a></$blk>\n</div>\n\n" ;

	/* Generate Index area */
	print "<div id=\"index_area\">\n" ;
	if (!is_dir($yamig_thumbs_dir))
		print "Warning: thumbnails directory '$yamig_thumbs_dir' not found." ;
	else if (!$thumbnails)
		print "Warning: no thumbnail found in directory '$yamig_thumbs_dir'" . ($yamig_thumbs_prefix ? " matching prefix '$yamig_thumbs_prefix'" : '') ;
	else if (!count($index))
		print "Warning: no image found for $thumbnails thumbnail(s)" ;
	for ($i = 0 ; $i < count($index) ; $i++)
		print ' <a href="' . $_SERVER['PHP_SELF'] . "?$getvars&amp;show[current]=$i\"><img src=\"$yamig_thumbs_dir/$yamig_thumbs_prefix$index[$i]\" alt=\"$index[$i]\" /></a>\n" ;
	print "</div>\n\n" ;
	}

//print '<div style="position: absolute; top: 40px; right: 40px; border: 3px solid red; padding: 8px; background-color: white; z-index: 10;">$_REQUEST was :<br /><pre>' ; print_r($_REQUEST) ; print "</pre></div>\n" ;
print "</div>\n</body>\n</html>\n" ;

?>

